package inmuebles.action;

 
import com.opensymphony.xwork2.ActionSupport; 
import com.opensymphony.xwork2.ModelDriven; 
import com.opensymphony.xwork2.Preparable; 
import inmuebles.beans.EstadisticaAnuncios; 
import inmuebles.modelos.ModeloEstadisticaDAO;
import org.apache.struts2.ServletActionContext;
import inmuebles.util.ExcepcionInmuebles;
import org.apache.struts2.dispatcher.SessionMap;
import org.apache.struts2.interceptor.SessionAware;
import java.util.Map;

/**
 * Acción que recupera estadisticas de anuncios.
 * 
 *
 * @author Ricardo de los Rios
 */


public class EstadisticasAnunciosAccion extends ActionSupport implements Preparable, ModelDriven, SessionAware
{ 
    /**
 * Objeto anuncio con la información actualizada.
 */
    private EstadisticaAnuncios estadistica;
    /**
 * Acceso a la sesión actual.
 */
    private Map<String,Object> sessionMap;
      
       public void prepare() throws Exception { 
              ModeloEstadisticaDAO modeloEstadisticaDAO=new ModeloEstadisticaDAO(); 
              
              estadistica=modeloEstadisticaDAO.getEstadisticaAnuncios();
      }

       /**
 * Acceso a la sesión actual.
 */
       
              
	public void setSession(Map<String,Object> map)
	{
		this.sessionMap=map;
	}
       /**
 * Obtiene información de la página jsp.
 */
       
      public Object getModel() { 
             return estadistica; 
      }
       /**
 * Obtiene información del anuncio.
 */
      public EstadisticaAnuncios getEstadisticaAnuncios() { 
             return estadistica; 
      }
       /**
 * Establece información del anuncio.
 */
      public void setEstadisticaAnuncios(EstadisticaAnuncios estadistica) { 
             this.estadistica= estadistica; 
      }
      
      /**
       *  Devuelve la lista de anuncios tras la recuperación 
       */
      public String execute() 
      { 
             return SUCCESS; 
      }

}