package inmuebles.action;


import java.util.ArrayList; 
import java.util.List; 
import com.opensymphony.xwork2.ActionSupport; 
import com.opensymphony.xwork2.ModelDriven; 
import com.opensymphony.xwork2.Preparable; 
import inmuebles.beans.Anuncio; 
import inmuebles.modelos.ModeloAnuncioDAO;
import org.apache.struts2.ServletActionContext;
import inmuebles.util.ExcepcionInmuebles;
import org.apache.struts2.dispatcher.SessionMap;
import org.apache.struts2.interceptor.SessionAware;
import java.util.Map;

/**
 * Acción que lista los anuncios de un usuario registrado.
 * 
 * Se utiliza la interfaz ModelDriven para realizar un mapeo automático entre el bean Usuario y los campos 
 * de la página jsp.
 *
 * @author Ricardo de los Rios
 */


public class ListadoAnuncioAccion extends ActionSupport implements Preparable, ModelDriven, SessionAware
{ 
    /**
 * Objeto anuncio con la información actualizada.
 */
    private Anuncio anuncio;
    /**
 * Lista de anuncios con la información actualizada.
 */
    private List<Anuncio> listaAnuncios; 
    /**
 * Codigo de usuario actual
 */
    
    private int idUsuarioActual=0;    
    /**
 * Acceso a la sesión actual.
 */
    
    private Map<String,Object> sessionMap;
      
        /**
 * Tratamiento segun el usuario actual.
 */
       public void prepare() throws Exception { 
              ModeloAnuncioDAO modeloAnuncioDAO=new ModeloAnuncioDAO(); 
              // en creación, crear un nuevo objeto vacío 
               
              if(sessionMap instanceof SessionMap)
              {
                  if (this.sessionMap.get("idusuario")!=null) {
                       idUsuarioActual=Integer.parseInt(this.sessionMap.get("idusuario").toString());
                  } 
                }    
       
                listaAnuncios=modeloAnuncioDAO.getListaAnuncios(idUsuarioActual); 
                               
                      
      }

       /**
 * Acceso a la sesión actual.
 */
       
              
	public void setSession(Map<String,Object> map)
	{
		this.sessionMap=map;
	}
       /**
 * Obtiene información de la página jsp.
 */
       
      public Object getModel() { 
             return anuncio; 
      }
       /**
 * Obtiene información del anuncio.
 */
      public Anuncio getAnuncio() { 
             return anuncio; 
      }
       /**
 * Establece información del anuncio.
 */
      public void setAnuncio(Anuncio anuncio) { 
             this.anuncio = anuncio; 
      }
       /**
 * Obtiene información de los anuncios anuncio.
 */
      public List<Anuncio> getListaAnuncios() { 
             ModeloAnuncioDAO ModeloAnuncioDAO=new ModeloAnuncioDAO();

             listaAnuncios=(ArrayList<Anuncio>)ModeloAnuncioDAO.getListaAnuncios(idUsuarioActual); 
             return listaAnuncios; 
      }
       /**
 * Establece información de los anuncios.
 */
      public void setListaAnuncios(List<Anuncio> listaAnuncios) { 
             this.listaAnuncios = listaAnuncios; 
      }

      
      /**
       *  Devuelve la lista de anuncios tras la recuperación 
       */
      public String execute() 
      { 
             return SUCCESS; 
      }

}