package inmuebles.action;


import java.util.ArrayList; 
import java.util.List; 
import com.opensymphony.xwork2.ActionSupport; 
import com.opensymphony.xwork2.ModelDriven; 
import com.opensymphony.xwork2.Preparable; 
import inmuebles.beans.Anuncio; 
import inmuebles.beans.Pais; 
import inmuebles.beans.Provincia; 
import inmuebles.beans.Distrito; 
import inmuebles.beans.TipoAccion; 
import inmuebles.beans.TipoInmueble; 
import inmuebles.beans.Alternativa; 
import inmuebles.beans.EstadoInmueble; 
import inmuebles.beans.Orientacion; 
import inmuebles.modelos.ModeloPaisDAO;
import inmuebles.modelos.ModeloProvinciaDAO;
import inmuebles.modelos.ModeloDistritoDAO;
import inmuebles.modelos.ModeloAnuncioDAO;
import org.apache.struts2.ServletActionContext;
import inmuebles.util.ExcepcionInmuebles;
import org.apache.struts2.dispatcher.SessionMap;
import org.apache.struts2.interceptor.SessionAware;
import java.util.Map;

/**
 * Acción que recupera un listado filtrado de anuncios.
 * 
 * Se utiliza la interfaz ModelDriven para realizar un mapeo automático entre el bean Usuario y los campos 
 * de la página jsp.
 * 
 * @author Ricardo de los Rios
 */


public class ListadoFiltrosAnuncioAccion extends ActionSupport implements Preparable, ModelDriven, SessionAware
{  
    /**
 * Objeto anuncio con la información actualizada.
 */
    private Anuncio anuncio;
      /**
 * Lista de anuncios con la información actualizada.
 */
    private List<Anuncio> listaAnuncios; 
       /**
 * Codigo de usuario actual
 */
    private int idUsuarioActual=0;    
      /**
 * Acceso a la sesión actual.
 */
    private Map<String,Object> sessionMap;
      /**
 * Lista de paises.
 */    
    private List<Pais> listaPaises=new ArrayList<Pais>(); 
      /**
 * Lista de provincias.
 */    

    private List<Provincia> listaProvincias=new ArrayList<Provincia>(); 
      /**
 * Lista de distritos.
 */    

    private List<Distrito> listaDistritos=new ArrayList<Distrito>(); 
      /**
 * Lista de tipos de accion.
 */    

    private List<TipoAccion> listaTipoAcciones=new ArrayList<TipoAccion>(); 
      /**
 * Lista de tipos de inmueble.
 */    

    private List<TipoInmueble> listaTipoInmuebles=new ArrayList<TipoInmueble>(); 
      /**
 * Lista de tipos de alternativas.
 */    

    private List<Alternativa> listaAlternativas=new ArrayList<Alternativa>(); 
     /**
 * Lista de estados de inmueble.
 */    

    private List<EstadoInmueble> listaEstadosInmueble=new ArrayList<EstadoInmueble>(); 
     /**
 * Lista de tipos de orientaciones.
 */      
    private List<Orientacion> listaOrientaciones=new ArrayList<Orientacion>(); 
        /**
 * Carga de los cuadros de selección.
 */
       public void prepare() throws Exception { 
              // en creación, crear un nuevo objeto vacío 
              
             ModeloPaisDAO modeloPaisDAO=new ModeloPaisDAO(); 
              listaPaises=modeloPaisDAO.getListaPaises();
              listaPaises.add(0, new Pais("","Todos"));
              ModeloProvinciaDAO modeloProvinciaDAO=new ModeloProvinciaDAO(); 
              listaProvincias=modeloProvinciaDAO.getListaProvincias();
              listaProvincias.add(0, new Provincia("","Todas"));
              ModeloDistritoDAO modeloDistritoDAO=new ModeloDistritoDAO(); 
              listaDistritos=modeloDistritoDAO.getListaDistritos();
              listaDistritos.add(0, new Distrito("","Todos"));

        listaAlternativas.add(new Alternativa("","Da lo mismo"));
        listaAlternativas.add(new Alternativa("S","Si"));
        listaAlternativas.add(new Alternativa("N","No"));
 
       listaTipoAcciones.add(new TipoAccion("","Cualquiera"));
       listaTipoAcciones.add(new TipoAccion("C","Comprar"));
       listaTipoAcciones.add(new TipoAccion("A","Alquilar"));
       listaTipoAcciones.add(new TipoAccion("O","Compartir"));

       listaEstadosInmueble.add(new EstadoInmueble("","Todos"));
       listaEstadosInmueble.add(new EstadoInmueble("P","En perfecto estado"));
       listaEstadosInmueble.add(new EstadoInmueble("R","A reformar"));
       
       listaOrientaciones.add(new Orientacion("","Da lo mismo"));
       listaOrientaciones.add(new Orientacion("S","Sur"));
       listaOrientaciones.add(new Orientacion("N","Norte"));
       listaOrientaciones.add(new Orientacion("E","Este"));
       listaOrientaciones.add(new Orientacion("O","Oeste"));
    
        listaTipoInmuebles.add(new TipoInmueble("","Todos"));
        listaTipoInmuebles.add(new TipoInmueble("V","Vivienda"));
        listaTipoInmuebles.add(new TipoInmueble("G","Garaje"));
        listaTipoInmuebles.add(new TipoInmueble("L","Local"));
        listaTipoInmuebles.add(new TipoInmueble("O","Otros"));
  
                      
      }

    public void setListaPaises(List<Pais> listaPaises) {
        this.listaPaises = listaPaises;
    }

    public List<Pais> getListaPaises() {    
        return listaPaises;
    }

    public void setListaProvincias(List<Provincia> listaProvincias) {
        this.listaProvincias = listaProvincias;
    }

    public List<Provincia> getListaProvincias() {    
        return listaProvincias;
    }

    public void setListaDistritos(List<Distrito> listaDistritos) {
        this.listaDistritos = listaDistritos;
    }

    public List<Distrito> getListaDistritos() {    
        return listaDistritos;
    }

    public void setListaTipoAcciones(List<TipoAccion> listaTipoAcciones) {
        this.listaTipoAcciones = listaTipoAcciones;
    }

    public List<TipoAccion> getListaTipoAcciones() {    
        return listaTipoAcciones;
    }

    public void setListaTipoInmuebles(List<TipoInmueble> listaTipoInmuebles) {
        this.listaTipoInmuebles = listaTipoInmuebles;
    }

   public List<TipoInmueble> getListaTipoInmuebles() {
        return listaTipoInmuebles;
    }

       public void setListaAlternativas(List<Alternativa> listaAlternativas) {
        this.listaAlternativas = listaAlternativas;
    }

   public List<Alternativa> getListaAlternativas() {
        
       return listaAlternativas;
    }

    public void setListaOrientaciones(List<Orientacion> listaOrientaciones) {
        this.listaOrientaciones = listaOrientaciones;
    }

   public List<Orientacion> getListaOrientaciones() {
        
       return listaOrientaciones;
    }

    public void setListaEstadosInmueble(List<EstadoInmueble> listaEstadosInmueble) {
        this.listaEstadosInmueble = listaEstadosInmueble;
    }

   public List<EstadoInmueble> getListaEstadosInmueble() {
        
       return listaEstadosInmueble;
    }

       
              	// acceso a la sesión
	public void setSession(Map<String,Object> map)
	{
		this.sessionMap=map;
	}

       
      public Object getModel() { 
             return anuncio; 
      }

      public Anuncio getAnuncio() { 
             return anuncio; 
      }

      public void setAnuncio(Anuncio anuncio) { 
             this.anuncio = anuncio; 
      }

      public List<Anuncio> getListaAnuncios() { 
             ModeloAnuncioDAO ModeloAnuncioDAO=new ModeloAnuncioDAO();

             listaAnuncios=(ArrayList<Anuncio>)ModeloAnuncioDAO.getListaAnuncios(idUsuarioActual); 
             return listaAnuncios; 
      }

      public void setListaAnuncios(List<Anuncio> listaAnuncios) { 
             this.listaAnuncios = listaAnuncios; 
      }

      // devolver la lista de anuncios tras la recuperacion 
      public String execute() 
      { 
             return SUCCESS; 
      }

}