package inmuebles.action;

import com.opensymphony.xwork2.ModelDriven; 
import com.opensymphony.xwork2.Preparable; 
import com.opensymphony.xwork2.ActionSupport;

import inmuebles.beans.LoginMailPwd;
import inmuebles.beans.Usuario;
import inmuebles.modelos.ModeloUsuarioDAO;
import inmuebles.util.ExcepcionInmuebles;
import inmuebles.util.ValidarEntrada;
import org.apache.struts2.dispatcher.SessionMap;
import org.apache.struts2.interceptor.SessionAware;
import java.util.Map;

/**
 * Acción encargada de gestionar el login de usuarios al portal.
 * 
 * @author Ricardo de los Ríos
 */


public class LoginInmueblesAccion extends ActionSupport implements Preparable, ModelDriven, SessionAware
{
    private LoginMailPwd LoginMailPwd;
    private Usuario Usuario;
    private Map<String,Object> sessionMap;

         public Object getModel() { 
             return LoginMailPwd; 
      }

       public void prepare() throws Exception { 
              
              // en creación, crear un nuevo objeto vacío 
                     LoginMailPwd=new LoginMailPwd();
                     LoginMailPwd.setCorreo("");
                     LoginMailPwd.setPassword("");
      }

       	// acceso a la sesión
	public void setSession(Map<String,Object> map)
	{
		this.sessionMap=map;
	}

public String execute() throws Exception
{
    try {
        ModeloUsuarioDAO modeloUsuarioDAO=new ModeloUsuarioDAO(); 
        
        if (LoginMailPwd.getCorreo().equals("") || LoginMailPwd.getPassword().equals(""))
            throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"Debe introducir el correo y el password.");
        
        if (!ValidarEntrada.checkEmail(LoginMailPwd.getCorreo()))
            throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"El correo electrónico no tiene el formato correcto.");
        
        Usuario=modeloUsuarioDAO.getUsuarioMail(LoginMailPwd.getCorreo(),LoginMailPwd.getPassword()); 
       
        if(sessionMap instanceof SessionMap)
	{
            if (LoginMailPwd.getCorreo().equals("director@inmuebles.es") && LoginMailPwd.getPassword().equals("director"))
            {
                this.sessionMap.put("tipousuariosesion",Usuario.USUARIO_DIRECTOR);
                return "director";
            }
            else {
                if (Usuario!=null) {
                    this.sessionMap.put("nombreusuariosesion",Usuario.getNombre());
                    this.sessionMap.put("tipousuariosesion",Usuario.getTipoUsuario());
                    this.sessionMap.put("idusuario", Usuario.getIdUsuario());
                }
                 else throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"El correo introducido no existe en el portal.");
                    
            }
	}
        
        return SUCCESS;
    }
    catch (ExcepcionInmuebles exc) {
        addActionError(exc.getRazon());
        return INPUT;
    }
    
}

    public Usuario getUsuario() {
        return Usuario;
    }

    public void setUsuario(Usuario Usuario) {
        this.Usuario = Usuario;
    }  
    

}
