package inmuebles.action;


 
import java.util.List; 
import com.opensymphony.xwork2.ActionSupport; 
import com.opensymphony.xwork2.ModelDriven; 
import com.opensymphony.xwork2.Preparable; 
import inmuebles.beans.Anuncio; 
import inmuebles.modelos.ModeloAnuncioDAO;
import inmuebles.util.ExcepcionInmuebles;
import org.apache.struts2.dispatcher.SessionMap;
import org.apache.struts2.interceptor.SessionAware;
import java.util.Map;

/**
 * Acción que recupera un listado filtrado de anuncios.
 * 
 * Se utiliza la interfaz ModelDriven para realizar un mapeo automático entre el bean Usuario y los campos 
 * de la página jsp.
 * 
 * @author Ricardo de los Rios
 */


public class ObtenerListaPisosAccion extends ActionSupport implements Preparable, ModelDriven, SessionAware
{ 
    private Anuncio anuncio;
    private List<Anuncio> listaAnuncios; 
    private int idUsuarioActual=0;    
    private Map<String,Object> sessionMap;

       public void prepare() throws Exception { 
            ModeloAnuncioDAO modeloAnuncioDAO=new ModeloAnuncioDAO();   
            String queryFiltro="";
                     
              if(sessionMap instanceof SessionMap)
              {
                  if (this.sessionMap.get("queryFiltro")!=null) {
                       queryFiltro=this.sessionMap.get("queryFiltro").toString();
                  } 
                }    
       
             listaAnuncios=modeloAnuncioDAO.getListaAnunciosFiltro(queryFiltro); 
          
      }
       
              	// acceso a la sesión
	public void setSession(Map<String,Object> map)
	{
		this.sessionMap=map;
	}

       
      public Object getModel() { 
             return anuncio; 
      }

      public Anuncio getAnuncio() { 
             return anuncio; 
      }

      public void setAnuncio(Anuncio anuncio) { 
             this.anuncio = anuncio; 
      }

      public List<Anuncio> getListaAnuncios() { 
             return listaAnuncios; 
      }

      public void setListaAnuncios(List<Anuncio> listaAnuncios) { 
             this.listaAnuncios = listaAnuncios; 
      }

      // devolver la lista de anuncios tras la recuperacion 
      public String execute() 
      { 
             return SUCCESS; 
      }

}