package inmuebles.action;

import com.opensymphony.xwork2.ActionSupport; 
import com.opensymphony.xwork2.ModelDriven; 
import inmuebles.beans.Anuncio;
import org.apache.struts2.dispatcher.SessionMap;
import org.apache.struts2.interceptor.SessionAware;
import java.util.Map;

/**
 * Acción que genera una cadena que define el filtro creado por el usuario.
 * 
 * Se utiliza la interfaz ModelDriven para realizar un mapeo automático entre el bean Filtro y los campos 
 * de la página jsp.
 * 
 * @author Ricardo de los Rios
 */


public class ObtenerPisoAccion extends ActionSupport implements ModelDriven, SessionAware
{
    private Anuncio anuncio;
    private String idAnuncio;
    private Map<String,Object> sessionMap;

    
              	// acceso a la sesión
	public void setSession(Map<String,Object> map)
	{
		this.sessionMap=map;
	}

       
      public Object getModel() { 
             return anuncio; 
      }

      // devolver la lista de anuncios tras la recuperacion 
      public String execute() 
      { 
          
        if(sessionMap instanceof SessionMap)
          {
              this.sessionMap.put("idAnuncio",idAnuncio);
          }    
          
             return SUCCESS; 
      }

    public String getIdAnuncio() {
        return idAnuncio;
    }

    public void setIdAnuncio(String idAnuncio) {
        this.idAnuncio = idAnuncio;
    }
      
      

}