package inmuebles.action;

import com.opensymphony.xwork2.ActionSupport; 
import com.opensymphony.xwork2.ModelDriven; 
import inmuebles.beans.Anuncio;
import inmuebles.beans.Filtro;
import org.apache.struts2.dispatcher.SessionMap;
import org.apache.struts2.interceptor.SessionAware;
import java.util.Map;

/**
 * Acción que genera una cadena que define el filtro creado por el usuario.
 * 
 * Se utiliza la interfaz ModelDriven para realizar un mapeo automático entre el bean Filtro y los campos 
 * de la página jsp.
 * 
 * @author Ricardo de los Rios
 */


public class ObtenerQueryFiltrosAccion extends ActionSupport implements ModelDriven, SessionAware
{ 
    private Anuncio anuncio;
     private Filtro filtro;
    private Map<String,Object> sessionMap;
    private String tipoAccion;

    public Filtro getFiltro() {
        return filtro;
    }

    public void setFiltro(Filtro filtro) {
        this.filtro = filtro;
    }
    
    public String getTipoAccion() {
        return tipoAccion;
    }

    public void setTipoAccion(String tipoAccion) {
        this.tipoAccion = tipoAccion;
    }
         
              	// acceso a la sesión
	public void setSession(Map<String,Object> map)
	{
		this.sessionMap=map;
	}

       
      public Object getModel() { 
             return anuncio; 
      }

      public Anuncio getAnuncio() { 
             return anuncio; 
      }

      public void setAnuncio(Anuncio anuncio) { 
             this.anuncio = anuncio; 
      }

      // devolver la lista de anuncios tras la recuperacion 
      public String execute() 
      { 
          StringBuffer queryFiltro=new StringBuffer();
         
          // Filtros relacionados con tabla anuncio
       
          if (anuncio.getProvincia()!=null) {
              if (anuncio.getProvincia().length()>0)                  
                queryFiltro.append(" AND i.provincia='").append(anuncio.getProvincia()).append("'");
          }
      
           if (anuncio.getDistrito()!=null) {
              if (!anuncio.getDistrito().equals(""))                 
                queryFiltro.append(" AND i.distrito='").append(anuncio.getDistrito()).append("'");
          }
      
          if (anuncio.getTipoAccion()!=null) {
              if (!anuncio.getTipoAccion().equals(""))
                queryFiltro.append(" AND a.tipoAccion='").append(anuncio.getTipoAccion()).append("'");
          }
   
          if (anuncio.getTipo_inmueble()!=null) {
              if (!anuncio.getTipo_inmueble().equals(""))
                  queryFiltro.append(" AND i.tipoPiso='").append(anuncio.getTipo_inmueble()).append("'");
          }
          
          if (anuncio.getEstado()!=null) {
              if (!anuncio.getEstado().equals(""))
                  queryFiltro.append(" AND a.estado='").append(anuncio.getEstado()).append("'");
          }
    
           if (anuncio.getOrientacion()!=null) {
              if (!anuncio.getOrientacion().equals(""))
                  queryFiltro.append(" AND i.orientacion='").append(anuncio.getOrientacion()).append("'");
          }
          
           if (anuncio.getAscensor()!=null) {
            if (anuncio.getAscensor().equals("S"))
                  queryFiltro.append(" AND i.ascensor='S'");
            if (anuncio.getAscensor().equals("N"))
                  queryFiltro.append(" AND i.ascensor='N'");
          }
       
          if (anuncio.getTrastero()!=null) {
            if (anuncio.getTrastero().equals("S"))
                  queryFiltro.append(" AND i.trastero='S'");
            if (anuncio.getTrastero().equals("N"))
                  queryFiltro.append(" AND i.trastero='N'");
          }
           
          if (anuncio.getAgua_caliente()!=null) {
            if (anuncio.getAgua_caliente().equals("S"))
                  queryFiltro.append(" AND i.aguaCalienteIndv='S'");
            if (anuncio.getAgua_caliente().equals("N"))
                  queryFiltro.append(" AND i.aguaCalienteIndv='N'");
          }
    
                 if (anuncio.getPiscina()!=null) {
            if (anuncio.getPiscina().equals("S"))
                  queryFiltro.append(" AND i.piscina='S'");
            if (anuncio.getPiscina().equals("N"))
                  queryFiltro.append(" AND i.piscina='N'");
          }
                            
          
        if(sessionMap instanceof SessionMap)
          {
              this.sessionMap.put("queryFiltro",queryFiltro.toString());
          }    
          
             return SUCCESS; 
      }

}