package inmuebles.action;


import java.util.ArrayList; 
import java.util.List; 
import com.opensymphony.xwork2.ActionSupport; 
import com.opensymphony.xwork2.ModelDriven; 
import com.opensymphony.xwork2.Preparable; 
import inmuebles.beans.Anuncio; 
import inmuebles.modelos.ModeloAnuncioDAO;
import inmuebles.modelos.ModeloPaisDAO;
import inmuebles.modelos.ModeloProvinciaDAO;
import inmuebles.modelos.ModeloDistritoDAO;
import org.apache.struts2.ServletActionContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import inmuebles.util.ExcepcionInmuebles;
import inmuebles.beans.TipoAccion; 
import inmuebles.beans.TipoInmueble; 
import inmuebles.beans.Alternativa; 
import inmuebles.beans.EstadoInmueble; 
import inmuebles.beans.Orientacion; 
import inmuebles.beans.Pais; 
import inmuebles.beans.Provincia; 
import inmuebles.beans.Distrito; 
import inmuebles.util.Singleton;


/**
 * Acción que maneja la agregación y edición de los anuncios de inmuebles.
 * 
 * Se utiliza la interfaz ModelDriven para realizar un mapeo automático entre el bean Usuario y los campos 
 * de la página jsp.
 * 
 * @author Ricardo de los Rios
 */

public class RegistroAnuncioAccion extends ActionSupport implements Preparable, ModelDriven {

    private Anuncio anuncio;
    private List<Anuncio> listaAnuncios; 
    private String idAnuncio="";
    private List<TipoAccion> listaTipoAcciones=new ArrayList<TipoAccion>(); 
    private List<TipoInmueble> listaTipoInmuebles=new ArrayList<TipoInmueble>(); 
    private List<Alternativa> listaAlternativas=new ArrayList<Alternativa>(); 
    private List<EstadoInmueble> listaEstadosInmueble=new ArrayList<EstadoInmueble>(); 
    private List<Orientacion> listaOrientaciones=new ArrayList<Orientacion>(); 
    private List<Pais> listaPaises=new ArrayList<Pais>(); 
    private List<Provincia> listaProvincias=new ArrayList<Provincia>(); 
    private List<Distrito> listaDistritos=new ArrayList<Distrito>(); 

       public void prepare() throws Exception {               
             if(idAnuncio=="") 
                   { 
                     anuncio=new Anuncio();
                   }
           
              ModeloPaisDAO modeloPaisDAO=new ModeloPaisDAO(); 
              listaPaises=modeloPaisDAO.getListaPaises();
              ModeloProvinciaDAO modeloProvinciaDAO=new ModeloProvinciaDAO(); 
              listaProvincias=modeloProvinciaDAO.getListaProvincias();
              ModeloDistritoDAO modeloDistritoDAO=new ModeloDistritoDAO(); 
              listaDistritos=modeloDistritoDAO.getListaDistritos();
              
              listaAlternativas=Singleton.getSingleton().getListaAlternativas();
              
       listaTipoAcciones.add(new TipoAccion("C","Comprar"));
       listaTipoAcciones.add(new TipoAccion("A","Alquilar"));
       listaTipoAcciones.add(new TipoAccion("O","Compartir"));

       listaEstadosInmueble.add(new EstadoInmueble("P","En perfecto estado"));
       listaEstadosInmueble.add(new EstadoInmueble("R","A reformar"));
       
       listaOrientaciones.add(new Orientacion("S","Sur"));
       listaOrientaciones.add(new Orientacion("N","Norte"));
       listaOrientaciones.add(new Orientacion("E","Este"));
       listaOrientaciones.add(new Orientacion("O","Oeste"));
       
        listaTipoInmuebles.add(new TipoInmueble("V","Vivienda"));
        listaTipoInmuebles.add(new TipoInmueble("G","Garaje"));
        listaTipoInmuebles.add(new TipoInmueble("L","Local"));
        listaTipoInmuebles.add(new TipoInmueble("O","Otros"));

       }

    public void setListaPaises(List<Pais> listaPaises) {
        this.listaPaises = listaPaises;
    }

    public List<Pais> getListaPaises() {    
        return listaPaises;
    }

    public void setListaProvincias(List<Provincia> listaProvincias) {
        this.listaProvincias = listaProvincias;
    }

    public List<Provincia> getListaProvincias() {    
        return listaProvincias;
    }

    public void setListaDistritos(List<Distrito> listaDistritos) {
        this.listaDistritos = listaDistritos;
    }

    public List<Distrito> getListaDistritos() {    
        return listaDistritos;
    }

    
    public void setListaTipoAcciones(List<TipoAccion> listaTipoAcciones) {
        this.listaTipoAcciones = listaTipoAcciones;
    }

    public List<TipoAccion> getListaTipoAcciones() {    
        return listaTipoAcciones;
    }

    public void setListaTipoInmuebles(List<TipoInmueble> listaTipoInmuebles) {
        this.listaTipoInmuebles = listaTipoInmuebles;
    }

   public List<TipoInmueble> getListaTipoInmuebles() {
        return listaTipoInmuebles;
    }

       public void setListaAlternativas(List<Alternativa> listaAlternativas) {
        this.listaAlternativas = listaAlternativas;
    }

   public List<Alternativa> getListaAlternativas() {
        
       return listaAlternativas;
    }

    public void setListaOrientaciones(List<Orientacion> listaOrientaciones) {
        this.listaOrientaciones = listaOrientaciones;
    }

   public List<Orientacion> getListaOrientaciones() {
        
       return listaOrientaciones;
    }

    public void setListaEstadosInmueble(List<EstadoInmueble> listaEstadosInmueble) {
        this.listaEstadosInmueble = listaEstadosInmueble;
    }

   public List<EstadoInmueble> getListaEstadosInmueble() {
        
       return listaEstadosInmueble;
    }

       
      public Object getModel() { 
             return anuncio; 
      }

      public String getIdAnuncio() { 
              return idAnuncio; 
      }

      public void setIdAnuncio(String idAnuncio) { 
             this.idAnuncio = idAnuncio; 
      }

      public Anuncio getAnuncio() { 
             return anuncio; 
      }

      public void setAnuncio(Anuncio anuncio) { 
             this.anuncio = anuncio; 
      }

      public List<Anuncio> getListaAnuncios() { 
             ModeloAnuncioDAO ModeloAnuncioDAO=new ModeloAnuncioDAO();

             //listaAnuncios=(ArrayList<Anuncio>)ModeloAnuncioDAO.getListaAnuncios(); 
             return listaAnuncios; 
      }

      public void setListaAnuncios(List<Anuncio> listaAnuncios) { 
             this.listaAnuncios = listaAnuncios; 
      }

      // devolver la lista de anuncios tras la recuperaci�n 
      public String obtener() 
      { 
             System.out.println("idanuncio:" + idAnuncio);
//              listaAnuncios=(ArrayList<Anuncio>)ModeloAnuncioDAO.getListaAnuncios(); 
             return SUCCESS; 
      }

      // agregar el anuncio al modelo 
      public String agregar() 
      { 
             
             ModeloAnuncioDAO ModeloAnuncioDAO=new ModeloAnuncioDAO(); 
             
              try {
                  
                  if (anuncio.getDireccion().equals(""))
                      throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"Debe introducir una dirección.");
                  
                  if (anuncio.getCodigo_postal().equals(""))
                      throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"Debe introducir un código postal.");
                  
                  if (anuncio.getPrecio().equals(""))
                      throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"Debe introducir un precio.");
                  else {
                      try {
                        double d=Double.parseDouble(anuncio.getPrecio());                                               
                      } catch (Exception ex) {
                            throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"El precio debe ser un valor monetario.");  
                      }
                  }      
                    
                  if (anuncio.getSuperficie().equals(""))
                      throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"Debe introducir la superficie.");
                    else {
                      try {
                        double d=Double.parseDouble(anuncio.getSuperficie());                                               
                      } catch (Exception ex) {
                            throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"La superficie debe ser un valor numérico.");  
                      }
                  }     
                  
                    if (anuncio.getNum_dorms().equals(""))
                      throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"Debe introducir el numero de dormitorios.");
                    else {
                      try {
                        Integer i=Integer.parseInt(anuncio.getNum_dorms());                                               
                      } catch (Exception ex) {
                            throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"El numero de dormitorios debe ser un valor numérico.");  
                      }
                  }     
                  
                    if (anuncio.getNum_banios().equals(""))
                      throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"Debe introducir el numero de baños.");
                    else {
                      try {
                        Integer i=Integer.parseInt(anuncio.getNum_banios());                                               
                      } catch (Exception ex) {
                            throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"El numero de baños debe ser un valor numérico.");  
                      }
                  }     

                    
                    HttpServletRequest request=ServletActionContext.getRequest();
                 HttpSession session=request.getSession();

                 anuncio.setIdUsuario(session.getAttribute("idusuario").toString());
                  
                 ModeloAnuncioDAO.agregarAnuncio(anuncio);
                 addActionMessage("correcto");
                 
                 session.setAttribute("idusuario",anuncio.getIdAnuncio());
                             
                return SUCCESS;  
                
             } catch (ExcepcionInmuebles ei) {
                
                if (ei.getTipoExcepcion().equals(ExcepcionInmuebles.EXCEPCION_FUNCIONAL)) {
                    
                    if (ei.getRazon().equals("ORA-00001: restricción única (ADMIN.UN_CORREO) violada")) {                        
                        addActionError("El correo electrónico introducido ya existe. Por favor, indique otro.");
                    }
                    else addActionError(ei.getRazon());
                    
                }
                                    
                return INPUT;
             }
            
                
              
      }
     

      // mostrar el formulario en edici�n 
      public String editar() 
      { 
             return SUCCESS; 
      }

      // modificar un anuncio 
/*
      public String modificar() 
      { 
             ModeloAnuncioDAO ModeloAnuncioDAO=new ModeloAnuncioDAO(); 
             ModeloAnuncioDAO.modificarAnuncio(anuncio); 
             return SUCCESS; 
      } */

      // eliminar un anuncio a partir del par�metro recibido llamado idAnuncio 
      public String eliminar() 
      { 
             ModeloAnuncioDAO ModeloAnuncioDAO=new ModeloAnuncioDAO(); 
             //ModeloAnuncioDAO.eliminarAnuncio(idAnuncioActual); 
             return SUCCESS; 
      }

 
      
}