package inmuebles.action;


import java.util.ArrayList; 
import java.util.List; 
import com.opensymphony.xwork2.ActionSupport; 
import com.opensymphony.xwork2.ModelDriven; 
import com.opensymphony.xwork2.Preparable; 
import inmuebles.beans.Pais;
import inmuebles.beans.Provincia;
import org.apache.struts2.ServletActionContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import inmuebles.beans.Usuario; 
import inmuebles.modelos.ModeloPaisDAO;
import inmuebles.modelos.ModeloProvinciaDAO;
import inmuebles.modelos.ModeloUsuarioDAO;
import inmuebles.util.ExcepcionInmuebles;
import inmuebles.util.ValidarEntrada;

/**
 * Acción que maneja la agregación y edición de los datos de los usuarios.
 * 
 * Se utiliza la interfaz ModelDriven para realizar un mapeo automático entre el bean Usuario y los campos 
 * de la página jsp.
 * 
 * @author Ricardo de los Rios
 */


public class RegistroUsuarioAccion extends ActionSupport implements Preparable, ModelDriven {

    private Usuario Usuario;
    private int idUsuarioActual;
   private List<Pais> listaPaises=new ArrayList<Pais>(); 
    private List<Provincia> listaProvincias=new ArrayList<Provincia>(); 
 
       public void prepare() throws Exception { 
           
             ModeloPaisDAO modeloPaisDAO=new ModeloPaisDAO(); 
              listaPaises=modeloPaisDAO.getListaPaises();
              ModeloProvinciaDAO modeloProvinciaDAO=new ModeloProvinciaDAO(); 
              listaProvincias=modeloProvinciaDAO.getListaProvincias();
              
              ModeloUsuarioDAO modeloUsuarioDAO=new ModeloUsuarioDAO(); 
              // en creación, crear un nuevo objeto vacío 
              if(idUsuarioActual==0) 
              { 
                     Usuario=new Usuario(); 
              } 
              // en modificación, devolver la información del objeto 
              else 
              {
                Usuario=modeloUsuarioDAO.getUsuario(idUsuarioActual); 
              } 
      }

      public Object getModel() { 
             return Usuario; 
      }

      public int getIdUsuarioActual() { 
              return idUsuarioActual; 
      }

      public void setIdUsuarioActual(int idUsuarioActual) { 
             this.idUsuarioActual = idUsuarioActual; 
      }

      public Usuario getUsuario() { 
             return Usuario; 
      }

      public void setUsuario(Usuario Usuario) { 
             this.Usuario = Usuario; 
      }
 public void setListaPaises(List<Pais> listaPaises) {
        this.listaPaises = listaPaises;
    }

    public List<Pais> getListaPaises() {    
        return listaPaises;
    }

    public void setListaProvincias(List<Provincia> listaProvincias) {
        this.listaProvincias = listaProvincias;
    }

    public List<Provincia> getListaProvincias() {    
        return listaProvincias;
    }

      // agregar el Usuario al modelo 
      public String agregar() 
      { 
             ModeloUsuarioDAO ModeloUsuarioDAO=new ModeloUsuarioDAO(); 

             try {
                 
               if (Usuario.getNombre().equals(""))
                  throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"Debe introducir su nombre.");
               if (Usuario.getApellidos().equals(""))
                  throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"Debe introducir sus apellidos.");
                if (Usuario.getDomicilio().equals(""))
                  throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"Debe introducir una dirección.");
                if (Usuario.getTelefono1().equals(""))
                  throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"Debe introducir al menos un telefono.");
              if (Usuario.getCorreo().equals("") || Usuario.getCorreoConfirmar().equals(""))
                  throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"Debe introducir el correo electrónico y su confirmación.");
              if (!Usuario.getCorreo().equals(Usuario.getCorreoConfirmar()))
                  throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"El correo electrónico y su confirmación no coinciden.");
              if (!ValidarEntrada.checkEmail(Usuario.getCorreo()))
                        throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"El correo electrónico no tiene el formato correcto.");
                      
              if (Usuario.getPassword().equals("") || Usuario.getPasswordConfirmar().equals(""))
                  throw new ExcepcionInmuebles(ExcepcionInmuebles.EXCEPCION_FUNCIONAL,"Debe introducir el password y su confirmación.");              
                 
                ModeloUsuarioDAO.agregarUsuario(Usuario);
                 addActionMessage("correcto");
                 
                 // Trasladamos el usuario a sesión
                 System.out.println("USUARIO: " + Usuario.getIdUsuario());
                 
                 HttpServletRequest request=ServletActionContext.getRequest();
                 HttpSession session=request.getSession();
                 session.setAttribute("idusuario",Usuario.getIdUsuario());
                             
                return SUCCESS;  
                
             } catch (ExcepcionInmuebles ei) {
                
                if (ei.getTipoExcepcion().equals(ExcepcionInmuebles.EXCEPCION_FUNCIONAL)) {
                    
                    if (ei.getRazon().equals("ORA-00001: restricción única (ADMIN.UN_CORREO) violada")) {                        
                        addActionError("El correo electrónico introducido ya existe. Por favor, indique otro.");
                    }
                    else addActionError(ei.getRazon());
                    
                }
                                    
                return INPUT;
             }
                
      }
     

      // mostrar el formulario en edición 
      public String editar() 
      { 
             return SUCCESS; 
      }

      // modificar un Usuario 
/*
      public String modificar() 
      { 
             ModeloUsuarioDAO ModeloUsuarioDAO=new ModeloUsuarioDAO(); 
             ModeloUsuarioDAO.modificarUsuario(Usuario); 
             return SUCCESS; 
      } */

      // eliminar un Usuario a partir del parámetro recibido llamado idUsuario 
      public String eliminar() 
      { 
             ModeloUsuarioDAO ModeloUsuarioDAO=new ModeloUsuarioDAO(); 
             ModeloUsuarioDAO.eliminarUsuario(idUsuarioActual); 
             return SUCCESS; 
      } 
}