package inmuebles.action;


import java.util.ArrayList; 
import java.util.List; 
import com.opensymphony.xwork2.ActionSupport; 
import com.opensymphony.xwork2.ModelDriven; 
import com.opensymphony.xwork2.Preparable; 
import inmuebles.beans.Anuncio; 
import inmuebles.beans.Pais; 
import inmuebles.beans.Provincia; 
import inmuebles.beans.Distrito; 
import inmuebles.beans.TipoAccion; 
import inmuebles.beans.TipoInmueble; 
import inmuebles.beans.Alternativa; 
import inmuebles.beans.EstadoInmueble; 
import inmuebles.beans.Orientacion; 
import inmuebles.modelos.ModeloPaisDAO;
import inmuebles.modelos.ModeloProvinciaDAO;
import inmuebles.modelos.ModeloDistritoDAO;
import inmuebles.modelos.ModeloAnuncioDAO;
import org.apache.struts2.ServletActionContext;
import inmuebles.util.ExcepcionInmuebles;
import org.apache.struts2.dispatcher.SessionMap;
import org.apache.struts2.interceptor.SessionAware;
import java.util.Map;

/**
 * Acción que recupera un listado filtrado de anuncios.
 * 
 * Se utiliza la interfaz ModelDriven para realizar un mapeo automático entre el bean Usuario y los campos 
 * de la página jsp.
 * 
 * @author Ricardo de los Rios
 */


public class VerPisoAccion extends ActionSupport implements Preparable, ModelDriven, SessionAware
{ 
    private Anuncio anuncio;
    private String idUsuarioActual;    
    private Map<String,Object> sessionMap;
    
       public void prepare() throws Exception {        
         ModeloAnuncioDAO modeloAnuncioDAO=new ModeloAnuncioDAO(); 
               
              if(sessionMap instanceof SessionMap)
              {
                  if (this.sessionMap.get("idAnuncio")!=null) {
                       idUsuarioActual=this.sessionMap.get("idAnuncio").toString();
                  } 
                }    
       
                anuncio=modeloAnuncioDAO.getAnuncio(idUsuarioActual); 
                      
      }

    
              	// acceso a la sesión
	public void setSession(Map<String,Object> map)
	{
		this.sessionMap=map;
	}

       
      public Object getModel() { 
             return anuncio; 
      }

      public Anuncio getAnuncio() { 
             return anuncio; 
      }

      public void setAnuncio(Anuncio anuncio) { 
             this.anuncio = anuncio; 
      }

      // devolver la lista de anuncios tras la recuperacion 
      public String execute() 
      { 
             return SUCCESS; 
      }

}