/**
 * Paquete con los beans java que encapsulan las entidades de negocio
 */

package inmuebles.beans;

/**
 * Bean Java que representa una seleccion entre varias opciones posibles para una entidad (Si/No/Cualquiera)
 * 
 * @author Ricardo de los Rios
 */

public class Alternativa {
    /** Codigo de la opción alternativa. */
    private String idAlternativa;
    /** Nombre de la opción alternativa */
    private String nombre;
    
    /** Constructor de una nueva opción alternativa
     * @param idAlternativa Codigo de la opción
     * @param nombre Descripción de la opción
     */
    
    public Alternativa(String idAlternativa,String nombre) {
        this.idAlternativa=idAlternativa;
        this.nombre=nombre;
    }
    
/**
 *  Método devuelve el código de una alternativa.
 * 
 * @return Código de la alternativa
 * 
 */
    public String getIdAlternativa() {
        return idAlternativa;
    }
/**
 *  Método que establece el código de una alternativa.
 * 
 * @param idAlternativa Código de la alternativa
 * 
 */
    public void setIdAlternativa(String idAlternativa) {
        this.idAlternativa = idAlternativa;
    }
 /**
 *  Método que devuelve la descripción de la alternativa
 * 
 * @return Descripción de la alternativa
 * 
 */

    public String getNombre() {
        return nombre;
    }

  /**
 *  Método que establece la descripción de la alternativa
 * 
 * @param nombre Descripción de la alternativa
 * 
 */
    public void setNombre(String nombre) {
        this.nombre = nombre;
    }
    
    
    
    }
