package inmuebles.beans;

/**
 * Bean Java que representa el anuncio de un inmueble.
 * 
 * @author Ricardo de los Rios
 */
public class Anuncio {
    
    /** Codigo de anuncio. */
    private String idAnuncio;
    /** Codigo de inmueble. */
    private String idInmueble;
    /** Codigo de usuario. */
    private String idUsuario;
    /** Fecha de publicación. */
    private String fecha_publicacion;
    /** Tipo de acción. */
    private String tipoAccion;    
    /** Tipo de inmueble. */
    private String tipo_inmueble;
    /** Estado del inmueble. */
    private String estado;
    /** Provincia del inmueble. */
    private String provincia;
    /** Distrito de inmueble. */
    private String distrito;
    /** Dirección de inmueble. */
    private String direccion;
    /** Código postal dle inmueble. */
    private String codigo_postal;
    /** Geolocalizacion del inmueble. */
    private String geolocalizacion;
    /** Precio del inmueble. */
    private String precio;
    /** Superficie del inmueble. */
    private String superficie;
    /** Orientación del inmueble. */
    private String orientacion;
    /** Numero de dormitorios del inmueble. */
    private String num_dorms;
    /** Numero de baños del inmueble. */
    private String num_banios;
    /** Ascensor del inmueble. */
    private String ascensor;
    /** Trastero del inmueble. */
    private String trastero;
    /** Armario del inmueble. */
    private String armarios;
    /** Terraza del inmueble. */
    private String terraza;
    /** Piscina del inmueble. */
    private String piscina;
    /** Aire acondicionado del inmueble. */
    private String aire_acond;
    /** Agua caliente del inmueble. */
    private String agua_caliente;
    /** Calefacción individual del inmueble. */
    private String calefaccion_indv;
    /** Foto del inmueble. */
    private String fotos;
    /** Descripción del inmueble. */
    private String descripcion;
    /** Exterior del inmueble. */
    private String exterior;
    /** Alquiler garantizado para el inmueble. */
    private String alquiler_garantizado;
       /** Alquiler garantizado para el inmueble. */
    private String fotopath;
    
/**
 *  Método que devuelve el codigo de un usuario
 * 
 * @return Codigo de usuario
 * 
 */

       public String getIdUsuario() {
        return idUsuario;
    }

       /**
 *  Método que establece el codigo de un usuario
 * 
 * @param idUsuario Codigo de usuario
 * 
 */
       
    public void setIdUsuario(String idUsuario) {
        this.idUsuario = idUsuario;
    }
 
    /**
 *  Método que devuelve el codigo postal
 * 
 * @return Codigo postal
 * 
 */

        public String getCodigo_postal() {
        return codigo_postal;
    }

            /**
 *  Método que establece el codigo postal
 * 
 * @param codigo_postal Codigo postal
 * 
 */
    public void setCodigo_postal(String codigo_postal) {
        this.codigo_postal = codigo_postal;
    }
/**
 *  Método que devuelve la direccion de un inmueble
 * 
 * @return Direccion
 * 
 */

    public String getDireccion() {
        return direccion;
    }
    
/**
 *  Método que establece la direccion de un inmueble
 * 
 * @param direccion Direccion
 * 
 */
    public void setDireccion(String direccion) {
        this.direccion = direccion;
    }

    /**
 *  Método que devuelve el codigo de un inmueble
 * 
 * @return Codigo de inmueble
 * 
 */

    public String getIdInmueble() {
        return idInmueble;
    }

        /**
 *  Método que establece el codigo de un inmueble
 * 
 * @param codigo Codigo de inmueble
 * 
 */
    
    public void setIdInmueble(String codigo) {
        this.idInmueble = codigo;
    
      
    }
    
    /**
 *  Método que devuelve si se requiere agua caliente
 * 
 * @return S/N/Otros
 * 
 */
    
    public String getAgua_caliente() {
        return agua_caliente;
    }

        /**
 *  Método que establece si se requiere agua caliente
 * 
 * @param agua_caliente S/N/Otros
 * 
 */
    public void setAgua_caliente(String agua_caliente) {
        this.agua_caliente = agua_caliente;
    }

  /**
 *  Método que devuelve si se requiere aire acondicionado
 * 
 * @return S/N/Otros
 * 
 */

    public String getAire_acond() {
        return aire_acond;
    }
  
    /**
 *  Método que establece si se requiere aire acondicionado
 * 
 * @param aire_acond S/N/Otros
 * 
 */
    public void setAire_acond(String aire_acond) {
        this.aire_acond = aire_acond;
    }

    /**
 *  Método que devuelve si tiene ascensor
 * 
 * @return S/N/Otros
 * 
 */

    public String getAscensor() {
        return ascensor;
    }

    /**
 *  Método que establece si tiene ascensor
 * 
 * @param ascensor S/N/Otros
 * 
 */  
    public void setAscensor(String ascensor) {
        this.ascensor = ascensor;
    }

    /**
 *  Método que devuelve si tiene calefaccion individual
 * 
 * @return S/N/Otros
 * 
 */

    public String getCalefaccion_indv() {
        return calefaccion_indv;
    }

       /**
 *  Método que establece si tiene calefaccion individual
 * 
 * @param calefaccion_indv S/N/Otros
 * 
 */
    public void setCalefaccion_indv(String calefaccion_indv) {
        this.calefaccion_indv = calefaccion_indv;
    }

/**
 *  Método que devuelve la descripción del inmueble
 * 
 * @return Descripcion
 * 
 */

    public String getDescripcion() {
        return descripcion;
    }

    /**
 *  Método que establece la descripción del inmueble
 * 
 * @param descripcion Descripcion
 * 
 */
    public void setDescripcion(String descripcion) {
        this.descripcion = descripcion;
    }

    /**
 *  Método que devuelve el distrito asociado
 * 
 * @return Distrito
 * 
 */

    public String getDistrito() {
        return distrito;
    }

    
    /**
 *  Método que establece el distrito asociado
 * 
 * @param distrito Distrito
 * 
 */
    public void setDistrito(String distrito) {
        this.distrito = distrito;
    }
/**
 *  Método que devuelve el estado de un inmueble
 * 
 * @return Descripcion del estado
 * 
 */

    public String getEstado() {
        return estado;
    }

    /**
 *  Método que establece el estado de un inmueble
 * 
 * @param estado Descripcion del estado
 * 
 */
    
    public void setEstado(String estado) {
        this.estado = estado;
    }
/**
 *  Método que devuelve si tiene fotos
 * 
 * @return S/N/Otros
 * 
 */

    public String getFotos() {
        return fotos;
    }

    /**
 *  Método que establece si tiene fotos
 * 
 * @param fotos S/N/Otros
 * 
 */
    
    public void setFotos(String fotos) {
        this.fotos = fotos;
    }
/**
 *  Método que devuelve el numero de baños
 * 
 * @return Numero de baños
 * 
 */

    public String getNum_banios() {
        return num_banios;
    }

    /**
 *  Método que establece el numero de baños
 * 
 * @param num_banios Numero de baños
 * 
 */
    
    public void setNum_banios(String num_banios) {
        this.num_banios = num_banios;
    }
/**
 *  Método que devuelve el numero de dormitorios
 * 
 * @return Numero de dormitorios
 * 
 */

    public String getNum_dorms() {
        return num_dorms;
    }

    /**
 *  Método que establece el numero de dormitorios
 * 
 * @param num_dorms Numero de dormitorios
 * 
 */
    
    public void setNum_dorms(String num_dorms) {
        this.num_dorms = num_dorms;
    }

    /**
 *  Método que devuelve la orientacion de un inmueble
 * 
 * @return Sur, este,..
 * 
 */

    public String getOrientacion() {
        return orientacion;
    }
 
        /**
 *  Método que establece la orientacion de un inmueble
 * 
 * @param orientacion Sur, este,..
 * 
 */
    public void setOrientacion(String orientacion) {
        this.orientacion = orientacion;
    }
/**
 *  Método que devuelve si tiene piscina
 * 
 * @return Si, no etc
 * 
 */

    public String getPiscina() {
        return piscina;
    }

 /**
 *  Método que establece si tiene piscina
 * 
 * @param piscina Si, no etc
 * 
 */
    
    public void setPiscina(String piscina) {
        this.piscina = piscina;
    }
/**
 *  Método que devuelve el precio del inmueble
 * 
 * @return Precio
 * 
 */

    public String getPrecio() {
        return precio;
    }

    /**
 *  Método que establece el precio del inmueble
 * 
 * @param precio Precio
 * 
 */
    
    public void setPrecio(String precio) {
        this.precio = precio;
    }
/**
 *  Método que devuelve la superficie de un inmueble
 * 
 * @return Superficie
 * 
 */

    public String getSuperficie() {
        return superficie;
    }
    
/**
 *  Método que establece la superficie de un inmueble
 * 
 * @param superficie Superficie
 * 
 */
    public void setSuperficie(String superficie) {
        this.superficie = superficie;
    }
/**
 *  Método que devuelve si tiene terraza
 * 
 * @return S/N/Otros
 * 
 */

    public String getTerraza() {
        return terraza;
    }

    /**
 *  Método que establece si tiene terraza
 * 
 * @param terraza S/N/Otros
 * 
 */
    public void setTerraza(String terraza) {
        this.terraza = terraza;
    }
/**
 *  Método que devuelve el tipo de un inmueble
 * 
 * @return Tipo de inmueble
 * 
 */

    public String getTipo_inmueble() {
        return tipo_inmueble;
    }
    
/**
 *  Método que establece el tipo de un inmueble
 * 
 * @param tipo_inmueble Tipo de inmueble
 * 
 */
    public void setTipo_inmueble(String tipo_inmueble) {
        this.tipo_inmueble = tipo_inmueble;
    }
/**
 *  Método que devuelve si tiene trastero
 * 
 * @return S/N/Otros
 * 
 */

    public String getTrastero() {
        return trastero;
    }

    /**
 *  Método que establece si tiene trastero
 * 
 * @param trastero S/N/Otros
 * 
 */
    public void setTrastero(String trastero) {
        this.trastero = trastero;

}
        /**
 *  Método que devuelve la geolocalizacion de un inmueble
 * 
 * @return Geolocalizacion
 * 
 */
    public String getGeolocalizacion() {
        return geolocalizacion;
    }
    /**
 *  Método que establece la geolocalizacion de un inmueble
 * 
 * @param geolocalizacion Geolocalizacion
 * 
 */
    public void setGeolocalizacion(String geolocalizacion) {
        this.geolocalizacion = geolocalizacion;
    }

    /**
 *  Método que devuelve si es exterior
 * 
 * @return S/N/Otros
 * 
 */

    public String getExterior() {
        return exterior;
    }

       /**
 *  Método que establece si es exterior
 * 
 * @param exterior S/N/Otros
 * 
 */
    public void setExterior(String exterior) {
        this.exterior = exterior;
    }

    /**
 *  Método que devuelve si se tiene alquiler garantizado
 * 
 * @return S/N/Otros
 * 
 */

    public String getAlquiler_garantizado() {
        return alquiler_garantizado;
    }

        /**
 *  Método que establece si se tiene alquiler garantizado
 * 
 * @param alquiler_garantizado S/N/Otros
 * 
 */
    
    public void setAlquiler_garantizado(String alquiler_garantizado) {
        this.alquiler_garantizado = alquiler_garantizado;
    }
/**
 *  Método que devuelve la fecha de publicacion de un inmueble
 * 
 * @return Fecha de publicacion
 * 
 */

    public String getFecha_publicacion() {
        return fecha_publicacion;
    }

    /**
 *  Método que establece la fecha de publicacion de un inmueble
 * 
 * @param fecha_publicacion Fecha de publicacion
 * 
 */
    public void setFecha_publicacion(String fecha_publicacion) {
        this.fecha_publicacion = fecha_publicacion;
    }

    /**
 *  Método que devuelve el codigo de un anuncio
 * 
 * @return Codigo de anuncio
 * 
 */

    public String getIdAnuncio() {
        return idAnuncio;
    }

        /**
 *  Método que establece el codigo de un anuncio
 * 
 * @param idAnuncio Codigo de anuncio
 * 
 */
    
    public void setIdAnuncio(String idAnuncio) {
        this.idAnuncio = idAnuncio;
    }
/**
 *  Método que devuelve el tipo de accion sobre un inmueble
 * 
 * @return Tipo de accion
 * 
 */

    public String getTipoAccion() {
        return tipoAccion;
    }

    /**
 *  Método que establece el tipo de accion sobre un inmueble
 * 
 * @param tipoAccion Tipo de accion
 * 
 */
    public void setTipoAccion(String tipoAccion) {
        this.tipoAccion = tipoAccion;
    }

/**
 *  Método que devuelve la provincia de un inmueble
 * 
 * @return Provincia
 * 
 */

    public String getProvincia() {
        return provincia;
    }

    /**
 *  Método que establece la provincia de un inmueble
 * 
 * @param provincia Provincia
 * 
 */
    
    public void setProvincia(String provincia) {
        this.provincia = provincia;
    }

    /**
 *  Método que devuelve si tiene armarios.
 * 
 * @return S/N/Otros
 * 
 */

    public String getArmarios() {
        return armarios;
    }

       /**
 *  Método que establece si tiene armarios.
 * 
 * @param armarios S/N/Otros
 * 
 */
    
    public void setArmarios(String armarios) {
        this.armarios = armarios;
    }

    public String getFotopath() {
        return fotopath;
    }

    public void setFotopath(String fotopath) {
        this.fotopath = fotopath;
    }

}
