package inmuebles.beans;

/**
 * Bean Java que representa un usuario del portal.
 * 
 * @author Ricardo de los Rios
 */
public class Usuario {
    
    public static final String USUARIO_DIRECTOR="D";
    public static final String USUARIO_REGISTRADO="N";
    public static final String USUARIO_PREMIUM="P";
    
    private String idUsuario;
    private String nombre;
    private String apellidos;
    private String domicilio;

    private String telefono1;
    private String telefono2;
    private String tipoUsuario;
    private String correo;
    private String correoConfirmar;
    private String password;
    private String passwordConfirmar;

    /**
 *  Método que devuelve el tipo de usuario
 * 
 * @return Tipo de usuario
 * 
 */

        public String getTipoUsuario() {
        return tipoUsuario;
    }

    public void setTipoUsuario(String tipoUsuario) {
        this.tipoUsuario = tipoUsuario;
    }
/**
 *  Método que devuelve el codigo de un usuario
 * 
 * @return codigo de usuario
 * 
 */

        public String getIdUsuario() {
        return idUsuario;
    }

    public void setIdUsuario(String idUsuario) {
        this.idUsuario = idUsuario;
    }

    /**
 *  Método que devuelve los apellidos de un usuario
 * 
 * @return Apellidos
 * 
 */

    public String getApellidos() {
        return apellidos;
    }

    public void setApellidos(String apellidos) {
        this.apellidos = apellidos;
    }
/**
 *  Método que devuelve el correo de un usuario
 * 
 * @return Correo
 * 
 */

    public String getCorreo() {
        return correo;
    }

    public void setCorreo(String correo) {
        this.correo = correo;
    }
/**
 *  Método que devuelve la confirmacion del correo del usuario
 * 
 * @return Confirmacion
 * 
 */

    public String getCorreoConfirmar() {
        return correoConfirmar;
    }

    public void setCorreoConfirmar(String correoConfirmar) {
        this.correoConfirmar = correoConfirmar;
    }
/**
 *  Método que devuelve el domicilio de un usuario
 * 
 * @return domicilio
 * 
 */

    public String getDomicilio() {
        return domicilio;
    }

    public void setDomicilio(String domicilio) {
        this.domicilio = domicilio;
    }
/**
 *  Método que devuelve el nombre de un usuario
 * 
 * @return Nombre de usuario
 * 
 */

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }
/**
 *  Método que devuelve el password de un usuario
 * 
 * @return Password
 * 
 */

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }
/**
 *  Método que devuelve la confirmacion del password de un usuario
 * 
 * @return Password
 * 
 */

    public String getPasswordConfirmar() {
        return passwordConfirmar;
    }

    public void setPasswordConfirmar(String passwordConfirmar) {
        this.passwordConfirmar = passwordConfirmar;
    }
/**
 *  Método que devuelve el primer telefono de un usuario
 * 
 * @return Telefono
 * 
 */

    public String getTelefono1() {
        return telefono1;
    }

    public void setTelefono1(String telefono1) {
        this.telefono1 = telefono1;
    }
/**
 *  Método que devuelve el segundo telefono de un usuario
 * 
 * @return Segundo telefono
 * 
 */

    public String getTelefono2() {
        return telefono2;
    }

    public void setTelefono2(String telefono2) {
        this.telefono2 = telefono2;
    }
    
  
}
