package inmuebles.modelos;

import java.sql.Connection; 
import java.sql.SQLException; 
import javax.servlet.ServletContext; 
import javax.sql.DataSource; 
import org.apache.struts2.ServletActionContext;

/**
 * Clase principal del patrón DAO, implementa la interfaz DAO. 
 * Será heredada por las clases del modelo que necesiten acceso a BD.
 * 
 * @author Ricardo de los Rios
 * @see DAO
 * @see ModeloUsuarioDAO
 */

// Clase de conexión 
public class ModeloDAO implements DAO 
{ 
  /**
 *  Instancia del pool de conexiones.
 */
       DataSource dataSource=null;

 /**
 *  Recupera una conexión a BD.
 * 
 * @return Conexion a base de datos.
 */
       
       public Connection getConnection() 
       { 
              ServletContext servletContext=ServletActionContext.getServletContext(); 
              if(this.dataSource==null) 
              {


dataSource=(DataSource)servletContext.getAttribute("dataSource"); 
              } 
              Connection connection=null; 
              if(dataSource!=null) 
              { 
                     try 
                     { 
                            connection=dataSource.getConnection(); 
                     } 
                     catch(SQLException e) 
                     { 
                            System.out.println(e); 
                     } 
               }

              // devolver la conexión 
              return connection; 
       }

 /**
 *  Proporciona el objeto conexión de base de datos.
 * 
 * @param dataSource Objeto pool de conexiones.
 */
       public void setConnection(DataSource dataSource) 
       { 
              this.dataSource=dataSource; 
       } 
}