package inmuebles.util;

import org.apache.log4j.Logger;
import java.net.URL;
import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.PropertyConfigurator;
import org.apache.log4j.helpers.Loader;
import inmuebles.beans.Alternativa;

/**
 * Singleton que contiene el log de la aplicación.
 *  
 * @author Ricardo de los Rios
 * @see inmuebles.beans.Alternativa
 */

public class LogInmuebles {
    
 
     /**
 *  Objeto con la instancia única de este Singleton.
 */ 
 private static org.apache.log4j.Logger singleton=null;
 
 /**
 *  Constructor vacío del singleton.
 * 
 */ 
    private LogInmuebles() {    }

 /**
 *  Devuelve la instancia única de este Singleton.
 * 
     * @return Singleton
 */ 
    static public Logger getSingleton() {

        if (singleton == null) {
             try {
                        URL url = Loader.getResource("log4j.properties");
                        PropertyConfigurator.configure(url);
                        singleton = Logger.getLogger("Registro");
                        System.out.println ("[" + url.toString() + "] Logger inicializado.");
                } catch (Exception e) {
                        BasicConfigurator.configure();
                        singleton = Logger.getLogger("Registro");
                        System.out.println ("Excepción al inicializar el log: " + e.toString());
                }
        }
        return singleton;
    }

}