package inmuebles.util;

import java.util.List;
import java.util.ArrayList;

import inmuebles.beans.Alternativa;

/**
 * Clase que carga datos y enumeraciones que permanecen constantes a lo largo de la ejecución.
 *  
 * @author Ricardo de los Rios
 * @see inmuebles.beans.Alternativa
 */

public class Singleton {

     /**
 *  Objeto con la instancia única de este Singleton.
 */ 
    static private Singleton singleton = null;
 
 /**
 *  Constructor del singleton.
 * 
 */ 
    private Singleton() { }

 /**
 *  Devuelve la instancia única de este Singleton.
 * 
     * @return Singleton
 */ 
    static public Singleton getSingleton() {

        if (singleton == null) {
            singleton = new Singleton();
        }
        return singleton;
    }

    /**
    * Establece los valores constantes de las alternativas
    * 
    * @return Lista de alternativas
    */

    public List<Alternativa> getListaAlternativas() {
        List<Alternativa> listaAlternativas=new ArrayList<Alternativa>();
        
       listaAlternativas.add(new Alternativa("N","No"));
       listaAlternativas.add(new Alternativa("N","Si"));
       
        return listaAlternativas;
    }

}